# $Date: 1996/09/19 08:47:06 $ $Author: frankp $ $Revision: 1.3 $ #

#--
	cos/rectform -- the function attribut "rectform" for cos
--#

cos := funcattr( cos, "rectform", proc(x)
	name cos::rectform;
        local a, b, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(cos)(rectform::expr(x)),rl)
        else
            a := extop(x,1);
            b := extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(cos(a+I*b))
            else
                new(rectform,cos(a)*cosh(b),-sin(a)*sinh(b),0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
